gstreamermm 1.8.0

Public Types | Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gst::AudioBaseSink Class Reference
gstreamermm Base Classes

The base class for audio sinks. More...

`#include <gstreamermm/audiobasesink.h>`

Inheritance diagram for Gst::AudioBaseSink:
[legend]

## Public Types
typedef sigc::slot< void, const Glib::RefPtr< Gst::AudioBaseSink >&, Gst::ClockTime, Gst::ClockTime, Gst::ClockTimeDiff&, Gst::AudioBaseSinkDiscontReason > | SlotCustomSlaving
| This slot is set with set_custom_slaving_callback() and is called during playback. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Public Member Functions
| AudioBaseSink (AudioBaseSink&& src) noexcept
AudioBaseSink& | operator= (AudioBaseSink&& src) noexcept
| ~AudioBaseSink () noexcept override
GstAudioBaseSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstAudioBaseSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstAudioBaseSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Clock > | get_provided_clock ()
| Get the Gst::Clock of the Gst::AudioBaseSink. More...
Glib::RefPtr< const Gst::Clock > | get_provided_clock () const
Glib::RefPtr< Gst::AudioRingBuffer > | create_ring_buffer ()
| Create and return the Gst::AudioRingBuffer for sink. More...
void | set_provide_clock (bool provide)
| Controls whether sink will provide a clock or not. More...
bool | get_provide_clock () const
| Queries whether sink will provide a clock or not. More...
void | set_slave_method (Gst::AudioBaseSinkSlaveMethod method)
| Controls how clock slaving will be performed in sink. More...
Gst::AudioBaseSinkSlaveMethod | get_slave_method () const
| Get the current slave method used by sink. More...
gint64 | get_drift_tolerance () const
| Get the current drift tolerance, in microseconds, used by sink. More...
void | set_drift_tolerance (gint64 drift_tolerance)
| Controls the sink's drift tolerance. More...
void | set_discont_wait (Gst::ClockTime discont_wait)
| Controls how long the sink will wait before creating a discontinuity. More...
Gst::ClockTime | get_discont_wait () const
| Get the current discont wait, in nanoseconds, used by sink. More...
void | set_alignment_threshold (Gst::ClockTime alignment_threshold)
| Controls the sink's alignment threshold. More...
Gst::ClockTime | get_alignment_threshold () const
| Get the current alignment threshold, in nanoseconds, used by sink. More...
void | report_device_failure ()
| Informs this base class that the audio output device has failed for some reason, causing a discontinuity (for example, because the device recovered from the error, but lost all contents of its ring buffer). More...
void | set_custom_slaving_callback (const SlotCustomSlaving& slot)
| Sets the custom slaving callback. More...
Glib::PropertyProxy< guint64 > | property_alignment_threshold ()
| Timestamp alignment threshold in nanoseconds. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_alignment_threshold () const
| Timestamp alignment threshold in nanoseconds. More...
Glib::PropertyProxy< gint64 > | property_buffer_time ()
| Size of audio buffer in microseconds, this is the minimum latency that the sink reports. More...
Glib::PropertyProxy_ReadOnly< gint64 > | property_buffer_time () const
| Size of audio buffer in microseconds, this is the minimum latency that the sink reports. More...
Glib::PropertyProxy< bool > | property_can_activate_pull ()
| Allow pull-based scheduling. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_activate_pull () const
| Allow pull-based scheduling. More...
Glib::PropertyProxy< guint64 > | property_discont_wait ()
| Window of time in nanoseconds to wait before creating a discontinuity. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_discont_wait () const
| Window of time in nanoseconds to wait before creating a discontinuity. More...
Glib::PropertyProxy< gint64 > | property_drift_tolerance ()
| Tolerance for clock drift in microseconds. More...
Glib::PropertyProxy_ReadOnly< gint64 > | property_drift_tolerance () const
| Tolerance for clock drift in microseconds. More...
Glib::PropertyProxy< gint64 > | property_latency_time ()
| The minimum amount of data to write in each iteration in microseconds. More...
Glib::PropertyProxy_ReadOnly< gint64 > | property_latency_time () const
| The minimum amount of data to write in each iteration in microseconds. More...
Glib::PropertyProxy< bool > | property_provide_clock ()
| Provide a clock to be used as the global pipeline clock. More...
Glib::PropertyProxy_ReadOnly< bool > | property_provide_clock () const
| Provide a clock to be used as the global pipeline clock. More...
Glib::PropertyProxy< Gst::AudioBaseSinkSlaveMethod > | property_slave_method ()
| Algorithm used to match the rate of the masterclock. More...
Glib::PropertyProxy_ReadOnly< Gst::AudioBaseSinkSlaveMethod > | property_slave_method () const
| Algorithm used to match the rate of the masterclock. More...
virtual Glib::RefPtr< Gst::AudioRingBuffer > | create_ring_buffer_vfunc ()
| vfunc to create and return a Gst::AudioRingBuffer to write to. More...
virtual Glib::RefPtr< Gst::Buffer > | payload_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| vfunc to payload data in a format suitable to write to the sink. More...
Public Member Functions inherited from Gst::BaseSink
| BaseSink (BaseSink&& src) noexcept
BaseSink& | operator= (BaseSink&& src) noexcept
| ~BaseSink () noexcept override
GstBaseSink* | gobj ()
| Provides access to the underlying C GObject. More...
const GstBaseSink* | gobj () const
| Provides access to the underlying C GObject. More...
GstBaseSink* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | query_latency (bool& live, bool& upstream_live, Gst::ClockTime& min_latency, Gst::ClockTime& max_latency) const
| Query the sink for the latency parameters. More...
Gst::ClockTime | get_latency () const
| Get the currently configured latency. More...
Gst::FlowReturn | do_preroll (const Glib::RefPtr< Gst::MiniObject >& obj)
| If the sink spawns its own thread for pulling buffers from upstream it should call this method after it has pulled a buffer. More...
Gst::FlowReturn | wait_preroll ()
| If the Gst::BaseSinkClass.render() method performs its own synchronisation against the clock it must unblock when going from PLAYING to the PAUSED state and call this method before continuing to render the remaining data. More...
Gst::ClockReturn | wait_clock (Gst::ClockTime time, Gst::ClockTimeDiff& jitter)
| This function will block until time is reached. More...
Gst::ClockReturn | wait_clock (Gst::ClockTime time)
| A wait_clock() convenience overload. More...
Gst::FlowReturn | wait (Gst::ClockTime time, Gst::ClockTimeDiff& jitter)
| This function will wait for preroll to complete and will then block until time is reached. More...
Gst::FlowReturn | wait (Gst::ClockTime time)
| A wait() convenience overload. More...
void | set_sync (bool sync)
| Configures sink to synchronize on the clock or not. More...
bool | get_sync () const
| Checks if sink is currently configured to synchronize against the clock. More...
void | set_max_lateness (gint64 max_lateness)
| Sets the new max lateness value to max_lateness. More...
gint64 | get_max_lateness () const
| Gets the max lateness value. More...
void | set_qos_enabled (bool enabled)
| Configures sink to send Quality-of-Service events upstream. More...
bool | is_qos_enabled () const
| Checks if sink is currently configured to send Quality-of-Service events upstream. More...
void | set_async_enabled (bool enabled)
| Configures sink to perform all state changes asynchronously. More...
bool | is_async_enabled () const
| Checks if sink is currently configured to perform asynchronous state changes to PAUSED. More...
void | set_ts_offset (Gst::ClockTimeDiff offset)
| Adjust the synchronisation of sink with offset. More...
Gst::ClockTimeDiff | get_ts_offset () const
| Get the synchronisation offset of sink. More...
void | set_render_delay (Gst::ClockTime delay)
| Set the render delay in sink to delay. More...
Gst::ClockTime | get_render_delay () const
| Get the render delay of sink. More...
void | set_blocksize (guint blocksize)
| Set the number of bytes that the sink will pull when it is operating in pull mode. More...
guint | get_blocksize () const
| Get the number of bytes that the sink will pull when it is operating in pull mode. More...
guint64 | get_throttle_time () const
| Get the time that will be inserted between frames to control the maximum buffers per second. More...
void | set_throttle_time (guint64 throttle)
| Set the time that will be inserted between rendered buffers. More...
Glib::RefPtr< Gst::Sample > | get_last_sample () const
| Get the last sample that arrived in the sink and was used for preroll or for rendering. More...
void | set_max_bitrate (guint64 max_bitrate)
| Set the maximum amount of bits per second that the sink will render. More...
guint64 | get_max_bitrate () const
| Get the maximum amount of bits per second that the sink will render. More...
void | set_last_sample_enabled (bool enabled)
| Configures sink to store the last received sample in the last-sample property. More...
bool | is_last_sample_enabled () const
| Checks if sink is currently configured to store the last received sample in the last-sample property. More...
Glib::RefPtr< Gst::Pad > | get_sink_pad ()
| Gets the sink Gst::Pad object of the element. More...
Glib::RefPtr< const Gst::Pad > | get_sink_pad () const
Glib::PropertyProxy< bool > | property_async ()
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy_ReadOnly< bool > | property_async () const
| Go asynchronously to PAUSED. More...
Glib::PropertyProxy< gint64 > | property_max_lateness ()
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy_ReadOnly< gint64 > | property_max_lateness () const
| Maximum number of nanoseconds that a buffer can be late before it is dropped (-1 unlimited). More...
Glib::PropertyProxy< bool > | property_qos ()
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy_ReadOnly< bool > | property_qos () const
| Generate Quality-of-Service events upstream. More...
Glib::PropertyProxy< bool > | property_sync ()
| Sync on the clock. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sync () const
| Sync on the clock. More...
Glib::PropertyProxy< gint64 > | property_ts_offset ()
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy_ReadOnly< gint64 > | property_ts_offset () const
| Timestamp offset in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_render_delay ()
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_render_delay () const
| Additional render delay of the sink in nanoseconds. More...
Glib::PropertyProxy< guint64 > | property_throttle_time ()
| The time to keep between rendered buffers (0 = disabled). More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_throttle_time () const
| The time to keep between rendered buffers (0 = disabled). More...
Glib::PropertyProxy< guint > | property_blocksize ()
| Size in bytes to pull per buffer (0 = default). More...
Glib::PropertyProxy_ReadOnly< guint > | property_blocksize () const
| Size in bytes to pull per buffer (0 = default). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gst::Sample > > | property_last_sample () const
| The last sample received in the sink. More...
Glib::PropertyProxy< bool > | property_enable_last_sample ()
| Enable the last-sample property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_enable_last_sample () const
| Enable the last-sample property. More...
Glib::PropertyProxy< guint64 > | property_max_bitrate ()
| The maximum bits per second to render (0 = disabled). More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_max_bitrate () const
| The maximum bits per second to render (0 = disabled). More...
virtual Glib::RefPtr< Gst::Caps > | get_caps_vfunc (const Glib::RefPtr< Gst::Caps >& caps) const
| Called to get sink pad caps from the subclass. More...
virtual bool | set_caps_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Notify subclass of changed caps. More...
virtual void | get_times_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer, Gst::ClockTime&start, Gst::ClockTime&end) const
| Called to get the start and end times for synchronising the passed buffer to the clock. More...
virtual bool | start_vfunc ()
| Start processing. More...
virtual bool | stop_vfunc ()
| Stop processing. More...
virtual bool | unlock_vfunc ()
| Unlock any pending access to the resource. More...
virtual bool | event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Override this to handle events arriving on the sink pad. More...
virtual FlowReturn | wait_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Override this to implement custom logic to wait for the event time (for events like EOS and GAP). More...
virtual FlowReturn | preroll_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called to present the preroll buffer if desired. More...
virtual FlowReturn | render_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called when a buffer should be presented or output, at the correct moment if the Gst::BaseSink has been set to sync to the clock. More...
virtual bool | activate_pull_vfunc (bool active)
| Subclasses should override this when they need to perform special processing when changing to the PLAYING state asynchronously. More...
virtual Glib::RefPtr< Gst::Caps > | fixate_vfunc (const Glib::RefPtr< Gst::Caps >& caps)
| Only useful in pull mode, this vmethod will be called in response to Gst::Pad::fixate_caps() being called on the sink pad. More...
virtual bool | unlock_stop_vfunc ()
| Clear the previous unlock request. More...
virtual FlowReturn | render_list_vfunc (const Glib::RefPtr< Gst::BufferList >& buffer_list)
| Render a BufferList. More...
virtual FlowReturn | prepare_vfunc (const Glib::RefPtr< Gst::Buffer >& buffer)
| Called to prepare the buffer for render and preroll. More...
virtual FlowReturn | prepare_list_vfunc (const Glib::RefPtr< Gst::BufferList >& buffer_list)
| Called to prepare the buffer list for render_list. More...
virtual bool | base_sink_query_vfunc (const Glib::RefPtr< Gst::Query >&query)
| Perform a GstQuery on the element. More...
virtual bool | propose_allocation_vfunc (const Glib::RefPtr< Gst::Query >&query)
| Configure the allocation query. More...
Public Member Functions inherited from Gst::Element
| Element (Element&& src) noexcept
Element& | operator= (Element&& src) noexcept
| ~Element () noexcept override
GstElement* | gobj ()
| Provides access to the underlying C GObject. More...
const GstElement* | gobj () const
| Provides access to the underlying C GObject. More...
GstElement* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest)
| Links this source element to the dest element. More...
bool | add_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Adds a pad (link point) to element. More...
void | create_all_pads ()
| Creates a pad for each pad template that is always available. More...
Glib::RefPtr< Gst::Pad > | create_compatible_pad (const Glib::RefPtr< const Gst::Pad >& pad, const Glib::RefPtr< const Gst::Caps >& caps)
| Looks for an unlinked pad to which the given pad can link. More...
Glib::RefPtr< Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl)
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< const Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl) const
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< Gst::Pad > | get_request_pad (const Glib::ustring& name)
| Retrieves a pad from the element by name (e.g. "src_\\%d"). More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Retrieves a request pad from the element according to the provided template. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::RefPtr< const Gst::Caps >& caps)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | get_static_pad (const Glib::ustring& name)
| Retrieves a pad from element by name. More...
Glib::RefPtr< const Gst::Pad > | get_static_pad (const Glib::ustring& name) const
| Retrieves a pad from element by name. More...
void | no_more_pads ()
| Use this function to signal that the element does not expect any more pads to show up in the current pipeline. More...
void | release_request_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Makes the element free the previously requested pad as obtained with get_request_pad(). More...
bool | remove_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Removes pad from element. More...
Gst::Iterator< Gst::Pad > | iterate_pads ()
| Retrieves an iterator of element's pads. More...
Gst::Iterator< const Gst::Pad > | iterate_pads () const
| Retrieves an iterator of element's pads. More...
Gst::Iterator< Gst::Pad > | iterate_sink_pads ()
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< const Gst::Pad > | iterate_sink_pads () const
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< Gst::Pad > | iterate_src_pads ()
| Retrieves an iterator of element's source pads. More...
Gst::Iterator< const Gst::Pad > | iterate_src_pads () const
| Retrieves an iterator of element's source pads. More...
void | unlink (const Glib::RefPtr< Gst::Element >& dest)
| Unlinks all source pads of the source element with all sink pads of the sink element to which they are linked. More...
void | set_context (const Glib::RefPtr< Gst::Context >& context)
| Sets the context of the element. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Links the two named pads of the source and destination elements. More...
void | unlink_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Unlinks the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, const Glib::RefPtr< Gst::Caps >& filter)
| Links the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, PadLinkCheck flags)
| Links the two named pads of the source and destination elements. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest, const Glib::RefPtr< Gst::Caps >& filter)
| Links src to dest using the given caps as filtercaps. More...
void | set_base_time (ClockTime time)
| Set the base time of an element. More...
ClockTime | get_base_time () const
| Returns the base time of the element. More...
void | set_start_time (Gst::ClockTime time)
| Set the start time of an element. More...
Gst::ClockTime | get_start_time () const
| Returns the start time of the element. More...
void | set_bus (const Glib::RefPtr< Gst::Bus >& bus)
| Sets the bus of the element. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Returns the bus of the element. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Returns the bus of the element. More...
Glib::RefPtr< Gst::ElementFactory > | get_factory ()
| Retrieves the factory that was used to create this element. More...
Glib::RefPtr< const Gst::ElementFactory > | get_factory () const
| Retrieves the factory that was used to create this element. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Sets the clock for the element. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the currently configured clock of the element. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the currently configured clock of the element. More...
Glib::RefPtr< Gst::Clock > | provide_clock ()
| Get the clock provided by the given element. More...
Glib::RefPtr< const Gst::Clock > | provide_clock () const
| Get the clock provided by the given element. More...
StateChangeReturn | set_state (State state)
| Sets the state of the element. More...
StateChangeReturn | get_state (State& state, State& pending, ClockTime timeout) const
| Gets the state of the element. More...
bool | set_locked_state (gboolean locked_state)
| Locks the state of an element, so state changes of the parent don't affect this element anymore. More...
bool | is_locked_state () const
| Checks if the state of an element is locked. More...
void | abort_state ()
| Abort the state change of the element. More...
StateChangeReturn | continue_state (StateChangeReturn ret)
| Commit the state change of the element and proceed to the next pending state if any. More...
void | lost_state ()
| Brings the element to the lost state. More...
bool | sync_state_with_parent ()
| Tries to change the state of the element to the same as its parent. More...
StateChangeReturn | change_state (StateChange transition)
| Perform transition on element. More...
void | post_message (int code, int line, MessageType type=Gst::MESSAGE_INFO, const Glib::QueryQuark& domain=get_core_error_quark(), const Glib::ustring& text=Glib::ustring(), const Glib::ustring& debug=Glib::ustring(), const Glib::ustring& file=Glib::ustring(), const Glib::ustring& function=Glib::ustring())
| Post an error, warning or info message on the bus from inside an element. More...
bool | post_message (Glib::RefPtr< Gst::Message >&& message)
| Post a message on the element's Gst::Bus. More...
bool | query (const Glib::RefPtr< Gst::Query >& query) const
| Performs a query on the given element. More...
bool | query_convert (Gst::Format src_format, gint64 src_val, Format dest_format, gint64& dest_val) const
| Queries an element to convert src_val in src_format to dest_format. More...
bool | query_position (Gst::Format format, gint64& cur) const
| Queries an element (usually top-level pipeline or playbin element) for the stream position in nanoseconds. More...
bool | query_position (Gst::Format format) const
| A query_position() convenience overload. More...
bool | query_duration (Gst::Format format, gint64& duration) const
| Queries an element (usually top-level pipeline or playbin element) for the total stream duration in nanoseconds. More...
bool | query_duration (Gst::Format format) const
| A query_duration() convenience overload. More...
bool | seek (Format format, SeekFlags seek_flags, gint64 seek_pos)
| Simple API to perform a seek on the given element, meaning it just seeks to the given position relative to the start of the stream. More...
bool | seek (double rate, Format format, SeekFlags flags, SeekType cur_type, gint64 cur, SeekType stop_type, gint64 stop)
| Sends a seek event to an element. More...
bool | send_event (Glib::RefPtr< Gst::Event >&& event)
| Sends an event to an element. More...
bool | send_event (const Glib::RefPtr< Gst::Event >& event)
| A send_event() convenience overload. Allows to re-use event parameter after function call. More...
Glib::RefPtr< Gst::Context > | get_context (const Glib::ustring& context_type)
| Gets the context with context_type set on the element or `nullptr`. More...
Glib::RefPtr< Gst::Context > | get_context_unlocked (const Glib::ustring& context_type)
| Gets the context with context_type set on the element or `nullptr`. More...
std::vector< Glib::RefPtr< Gst::Context > > | get_contexts ()
| Gets the contexts set on the element. More...
Glib::SignalProxy< void > | signal_no_more_pads ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Pad >&> | signal_pad_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Pad >&> | signal_pad_removed ()
virtual void | release_pad_vfunc (const Glib::RefPtr< Gst::Pad >& pad)
| Called when a request pad is to be released. More...
virtual Glib::RefPtr< Gst::Pad > | request_new_pad_vfunc (Glib::RefPtr< Gst::PadTemplate > templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Called when a new pad is requested. More...
virtual StateChangeReturn | get_state_vfunc (State& state, State& pending, ClockTime timeout) const
| Get the state of the element. More...
virtual StateChangeReturn | set_state_vfunc (State state)
| Set a new state on the element. More...
virtual StateChangeReturn | change_state_vfunc (StateChange transition)
| Called by set_state to perform an incremental state change. More...
virtual void | state_changed_vfunc (Gst::State oldstate, Gst::State newstate, Gst::State pending)
| Called immediately after a new state was set. More...
virtual void | set_bus_vfunc (const Glib::RefPtr< Gst::Bus >& bus)
| Set a Gst::Bus on the element. More...
virtual Glib::RefPtr< Gst::Clock > | provide_clock_vfunc ()
| Gets the Gst::Clock provided by the element. More...
virtual bool | set_clock_vfunc (const Glib::RefPtr< Gst::Clock >& clock)
| Set the Gst::Clock on the element. More...
virtual bool | send_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Send a Gst::Event to the element. More...
virtual bool | query_vfunc (const Glib::RefPtr< Gst::Query >&query) const
| Perform a Gst::Query on the element. More...
virtual void | set_context_vfunc (const Glib::RefPtr< Gst::Context >& context)
| Set a Gst::Context on the element. More...
virtual bool | post_message_vfunc (const Glib::RefPtr< Gst::Message >& message)
| Called when a message is posted on the element. More...
Glib::RefPtr< Gst::PadTemplate > | get_pad_template (const Glib::ustring& factory_name) const
template<typename T >
Glib::RefPtr< Gst::Element > | property (const Glib::ustring& name, const T& value)
| Sets specified property. More...
Public Member Functions inherited from Gst::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `nullptr`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
void | set_control_rate (Gst::ClockTime control_rate)
| Change the control-rate for this object. More...
Gst::ClockTime | get_control_rate () const
| Obtain the control-rate for this object. More...
Gst::ClockTime | suggest_next_sync () const
| Returns a suggestion for timestamps where buffers should be split to get best controller results. More...
bool | sync_values (Gst::ClockTime timestamp)
| Sets the properties of the object, according to the Gst::ControlSources that (maybe) handle them and for the given timestamp. More...
void | set_control_bindings_disabled (bool disabled)
| This function is used to disable all controlled properties of the object for some time, i.e. sync_values() will do nothing. More...
bool | has_asctive_control_bindings () const
| Check if the object has an active controlled properties. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_ancestor (const Glib::RefPtr< Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_parent (const Glib::RefPtr< Gst::Object >& parent) const
| Check if parent is the parent of object. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the object. More...
Glib::PropertyProxy< Glib::RefPtr< Gst::Object > > | property_parent ()
| The parent of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gst::Object > > | property_parent () const
| The parent of the object. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Object >&, GParamSpec*> | signal_deep_notify ()
int | get_refcount () const
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::BaseSink
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Element
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::AudioBaseSink > | wrap (GstAudioBaseSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::BaseSink
Glib::RefPtr< Gst::BaseSink > | wrap (GstBaseSink* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Element
Glib::RefPtr< Gst::Element > | wrap (GstElement* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Protected Member Functions inherited from Gst::Element
virtual void | on_no_more_pads ()
| This is a default handler for the signal signal_no_more_pads(). More...
virtual void | on_pad_added (const Glib::RefPtr< Gst::Pad >& new_pad)
| This is a default handler for the signal signal_pad_added(). More...
virtual void | on_pad_removed (const Glib::RefPtr< Gst::Pad >& old_pad)
| This is a default handler for the signal signal_pad_removed(). More...
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Gst::Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Detailed Description

The base class for audio sinks.

This is the base class for audio sinks. Subclasses need to implement the create_ringbuffer_vfunc vmethod. This base class will then take care of writing samples to the audioringbuffer, synchronisation, clipping and flushing.

Last reviewed on 2016-04-23 (1.8.0).

## Member Typedef Documentation

## § SlotCustomSlaving

typedef sigc::slot<void, const Glib::RefPtr<Gst::AudioBaseSink>&, Gst::ClockTime, Gst::ClockTime, Gst::ClockTimeDiff&, Gst::AudioBaseSinkDiscontReason> Gst::AudioBaseSink::SlotCustomSlaving

This slot is set with set_custom_slaving_callback() and is called during playback.

It receives the current time of external and internal clocks, which the callback can then use to apply any custom slaving/synchronization schemes.

The external clock is the sink's element clock, the internal one is the internal audio clock. The internal audio clock's calibration is applied to the timestamps before they are passed to the callback. The difference between etime and itime is the skew; how much internal and external clock lie apart from each other. A skew of 0 means both clocks are perfectly in sync. itime > etime means the external clock is going slower, while itime < etime means it is going faster than the internal clock. etime and itime are always valid timestamps, except for when a discontinuity happens.

requested_skew is an output value the callback can write to. It informs the sink of whether or not it should move the playout pointer, and if so, by how much. This pointer is only nullptr if a discontinuity occurs; otherwise, it is safe to write to *requested_skew. The default skew is 0.

The sink may experience discontinuities. If one happens, discont is TRUE, itime, etime are set to CLOCK_TIME_NONE, and requested_skew is nullptr. This makes it possible to reset custom clock slaving algorithms when a discontinuity happens.

## Constructor & Destructor Documentation

## § AudioBaseSink()

Gst::AudioBaseSink::AudioBaseSink | ( | AudioBaseSink&& | src | ) |
| noexcept

## § ~AudioBaseSink()

Gst::AudioBaseSink::~AudioBaseSink | ( |  | ) |
| override noexcept

## Member Function Documentation

## § create_ring_buffer()

Glib::RefPtr<Gst::AudioRingBuffer> Gst::AudioBaseSink::create_ring_buffer | ( |  | ) |

Create and return the Gst::AudioRingBuffer for sink.

This function will call the ::create_ringbuffer vmethod and will set sink as the parent of the returned buffer (see Gst::Object::set_parent()).

Returns
  The new ringbuffer of sink.

## § create_ring_buffer_vfunc()

virtual Glib::RefPtr<Gst::AudioRingBuffer> Gst::AudioBaseSink::create_ring_buffer_vfunc | ( |  | ) |
| virtual

vfunc to create and return a Gst::AudioRingBuffer to write to.

## § get_alignment_threshold()

Gst::ClockTime Gst::AudioBaseSink::get_alignment_threshold | ( |  | ) | const

Get the current alignment threshold, in nanoseconds, used by sink.

Returns
  The current alignment threshold used by sink.

## § get_discont_wait()

Gst::ClockTime Gst::AudioBaseSink::get_discont_wait | ( |  | ) | const

Get the current discont wait, in nanoseconds, used by sink.

Returns
  The current discont wait used by sink.

## § get_drift_tolerance()

gint64 Gst::AudioBaseSink::get_drift_tolerance | ( |  | ) | const

Get the current drift tolerance, in microseconds, used by sink.

Returns
  The current drift tolerance used by sink.

## § get_provide_clock()

bool Gst::AudioBaseSink::get_provide_clock | ( |  | ) | const

Queries whether sink will provide a clock or not.

See also gst_audio_base_sink_set_provide_clock.

Returns
  `true` if sink will provide a clock.

## § get_provided_clock() [1/2]

Glib::RefPtr<Gst::Clock> Gst::AudioBaseSink::get_provided_clock | ( |  | ) |

Get the Gst::Clock of the Gst::AudioBaseSink.

## § get_provided_clock() [2/2]

Glib::RefPtr<const Gst::Clock> Gst::AudioBaseSink::get_provided_clock | ( |  | ) | const

## § get_slave_method()

Gst::AudioBaseSinkSlaveMethod Gst::AudioBaseSink::get_slave_method | ( |  | ) | const

Get the current slave method used by sink.

Returns
  The current slave method used by sink.

## § get_type()

static GType Gst::AudioBaseSink::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## § gobj() [1/2]

GstAudioBaseSink* Gst::AudioBaseSink::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## § gobj() [2/2]

const GstAudioBaseSink* Gst::AudioBaseSink::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## § gobj_copy()

GstAudioBaseSink* Gst::AudioBaseSink::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## § operator=()

AudioBaseSink& Gst::AudioBaseSink::operator= | ( | AudioBaseSink&& | src | ) |
| noexcept

## § payload_vfunc()

virtual Glib::RefPtr<Gst::Buffer> Gst::AudioBaseSink::payload_vfunc | ( | const Glib::RefPtr< Gst::Buffer >& | buffer | ) |
| virtual

vfunc to payload data in a format suitable to write to the sink.

If no payloading is required, returns a reffed copy of the original buffer, else returns the payloaded buffer with all other metadata copied.

## § property_alignment_threshold() [1/2]

Glib::PropertyProxy< guint64 > Gst::AudioBaseSink::property_alignment_threshold | ( |  | ) |

Timestamp alignment threshold in nanoseconds.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_alignment_threshold() [2/2]

Glib::PropertyProxy_ReadOnly< guint64 > Gst::AudioBaseSink::property_alignment_threshold | ( |  | ) | const

Timestamp alignment threshold in nanoseconds.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_buffer_time() [1/2]

Glib::PropertyProxy< gint64 > Gst::AudioBaseSink::property_buffer_time | ( |  | ) |

Size of audio buffer in microseconds, this is the minimum latency that the sink reports.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_buffer_time() [2/2]

Glib::PropertyProxy_ReadOnly< gint64 > Gst::AudioBaseSink::property_buffer_time | ( |  | ) | const

Size of audio buffer in microseconds, this is the minimum latency that the sink reports.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_can_activate_pull() [1/2]

Glib::PropertyProxy< bool > Gst::AudioBaseSink::property_can_activate_pull | ( |  | ) |

Allow pull-based scheduling.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_can_activate_pull() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gst::AudioBaseSink::property_can_activate_pull | ( |  | ) | const

Allow pull-based scheduling.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_discont_wait() [1/2]

Glib::PropertyProxy< guint64 > Gst::AudioBaseSink::property_discont_wait | ( |  | ) |

Window of time in nanoseconds to wait before creating a discontinuity.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_discont_wait() [2/2]

Glib::PropertyProxy_ReadOnly< guint64 > Gst::AudioBaseSink::property_discont_wait | ( |  | ) | const

Window of time in nanoseconds to wait before creating a discontinuity.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_drift_tolerance() [1/2]

Glib::PropertyProxy< gint64 > Gst::AudioBaseSink::property_drift_tolerance | ( |  | ) |

Tolerance for clock drift in microseconds.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_drift_tolerance() [2/2]

Glib::PropertyProxy_ReadOnly< gint64 > Gst::AudioBaseSink::property_drift_tolerance | ( |  | ) | const

Tolerance for clock drift in microseconds.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_latency_time() [1/2]

Glib::PropertyProxy< gint64 > Gst::AudioBaseSink::property_latency_time | ( |  | ) |

The minimum amount of data to write in each iteration in microseconds.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_latency_time() [2/2]

Glib::PropertyProxy_ReadOnly< gint64 > Gst::AudioBaseSink::property_latency_time | ( |  | ) | const

The minimum amount of data to write in each iteration in microseconds.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_provide_clock() [1/2]

Glib::PropertyProxy< bool > Gst::AudioBaseSink::property_provide_clock | ( |  | ) |

Provide a clock to be used as the global pipeline clock.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_provide_clock() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gst::AudioBaseSink::property_provide_clock | ( |  | ) | const

Provide a clock to be used as the global pipeline clock.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § property_slave_method() [1/2]

Glib::PropertyProxy< Gst::AudioBaseSinkSlaveMethod > Gst::AudioBaseSink::property_slave_method | ( |  | ) |

Algorithm used to match the rate of the masterclock.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## § property_slave_method() [2/2]

Glib::PropertyProxy_ReadOnly< Gst::AudioBaseSinkSlaveMethod > Gst::AudioBaseSink::property_slave_method | ( |  | ) | const

Algorithm used to match the rate of the masterclock.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## § report_device_failure()

void Gst::AudioBaseSink::report_device_failure | ( |  | ) |

Informs this base class that the audio output device has failed for some reason, causing a discontinuity (for example, because the device recovered from the error, but lost all contents of its ring buffer).

This function is typically called by derived classes, and is useful for the custom slave method.

## § set_alignment_threshold()

void Gst::AudioBaseSink::set_alignment_threshold | ( | Gst::ClockTime | alignment_threshold | ) |

Controls the sink's alignment threshold.

Parameters

  alignment_threshold | The new alignment threshold in nanoseconds.

## § set_custom_slaving_callback()

void Gst::AudioBaseSink::set_custom_slaving_callback | ( | const SlotCustomSlaving& | slot | ) |

Sets the custom slaving callback.

This callback will be invoked if the slave-method property is set to GST_AUDIO_BASE_SINK_SLAVE_CUSTOM and the audio sink receives and plays samples.

Setting the callback to `nullptr` causes the sink to behave as if the GST_AUDIO_BASE_SINK_SLAVE_NONE method were used.

Parameters

  slot | A Gst::SlotAudioBaseSinkCustomSlaving.
  user_data | User data passed to the callback.
  notify | Called when user_data becomes unused.

## § set_discont_wait()

void Gst::AudioBaseSink::set_discont_wait | ( | Gst::ClockTime | discont_wait | ) |

Controls how long the sink will wait before creating a discontinuity.

Parameters

  discont_wait | The new discont wait in nanoseconds.

## § set_drift_tolerance()

void Gst::AudioBaseSink::set_drift_tolerance | ( | gint64 | drift_tolerance | ) |

Controls the sink's drift tolerance.

Parameters

  drift_tolerance | The new drift tolerance in microseconds.

## § set_provide_clock()

void Gst::AudioBaseSink::set_provide_clock | ( | bool | provide | ) |

Controls whether sink will provide a clock or not.

If provide is `true`, Gst::Element::provide_clock() will return a clock that reflects the datarate of sink. If provide is `false`, Gst::Element::provide_clock() will return `nullptr`.

Parameters

  provide | New state.

## § set_slave_method()

void Gst::AudioBaseSink::set_slave_method | ( | Gst::AudioBaseSinkSlaveMethod | method | ) |

Controls how clock slaving will be performed in sink.

Parameters

  method | The new slave method.

## Friends And Related Function Documentation

## § wrap()

Glib::RefPtr< Gst::AudioBaseSink > wrap | ( | GstAudioBaseSink * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.